using System;

using System.Collections.Generic;

using System.IO;

using UnityEngine;

using UnityEngine.Events;

namespace Mod


{

    public class Mod

    {

        public static void Main()

        {
                   ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "(Austria/Military) SENTRY XP Mid Cut Helmet",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Made in the US and was bought by the Austrians. Including lots of extras that come with the helmet like Face shield.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at1.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at1.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(Austria/Military) Shoulder Protection 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Made from Kevlar. Used to protect the wearer from shrapnell splinters that hit the shoulders",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at2.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at2.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperArmFront";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(Austria/Military) Shoulder Protection 2",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Made from Kevlar. Used to protect the wearer from shrapnell splinters that hit the shoulders",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at2.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at2.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(Austria/Military) Plate Carrier 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Upper Part of a Plate carrier made out of kevlar",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at3.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at3.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(Austria/Military) Plate Carrier 2",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Has 4 Ceramic Plates inserted.1front,1back,2sides.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at4.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at4.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "MiddleBody";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(Austria/Military) Plate Carrier 3",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Has additional groin protection.Mostly used during assaults",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at5.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at5.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "LowerBody";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Insulator"),
                    NameOverride = "(Austria/Military) SENTRY XP Mid Cut Helmet with Face Shield",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = " SENTRY XP Mid Cut Helmet with Face Shield. Is able to withstand small arms fire.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at6.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at6.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(Austria/Military) Olive green Balaklava",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Made out of nylon. Used to protect the Indentity of the wearer and looks cool.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at7.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at7.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(Austria/Military) Knee Protection 1",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Made out of hard polymer.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at8.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at8.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperLegFront";
                        armor.armorTier = 0;
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),
                    NameOverride = "(Austria/Military) Knee Protection 2",
                    NameToOrderByOverride = "A5",
                    DescriptionOverride = "Made out of hard polymer.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("at8.png", 5f, true),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at8.png", 1f, true);
						Instance.FixColliders();
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 0f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 0;
                    }
                }
            );
 ModAPI.Register(new Modification()
      {
        OriginalItem =  ModAPI.FindSpawnable("Pistol"),
        NameOverride =  "(Austria/Military) Glock 17",
               DescriptionOverride =  "painted Olive reen to blend in.Very good gun.",
        CategoryOverride =  ModAPI.FindCategory("Entities"),
        ThumbnailOverride = ModAPI.LoadSprite("at9.png", 5f, true),
        AfterSpawn =  (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at9.png", 1f, true);
          Utils.FixColliders(Instance);

                    Instance.GetComponent<FirearmBehaviour>().ShotSounds =  new AudioClip[1]
          {
            ModAPI.LoadSound("hp.mp3")
          };
        })
      });
       ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "(Austria/Military) Austrian Solider ", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "A well equipped foot solider", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("at10.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("at10.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");
            
            
            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
       ModAPI.Register(new Modification()
      {
        OriginalItem =  ModAPI.FindSpawnable("Assault Rifle"),
        NameOverride =  "(Austria/Military) Stg 77 (Styr AUG)",
               DescriptionOverride =  "The standard issue rifle for the Austrian Army.It was introduced in the 70s but is still used by lots of other countries",
        CategoryOverride =  ModAPI.FindCategory("Entities"),
        ThumbnailOverride = ModAPI.LoadSprite("aug.png", 5f, true),
        AfterSpawn =  (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("aug.png", 1f, true);
          Utils.FixColliders(Instance);

                    Instance.GetComponent<FirearmBehaviour>().ShotSounds =  new AudioClip[1]
          {
            ModAPI.LoadSound("rem.mp3")
          };
        })
      });
ModAPI.Register(new Modification()
      {
        OriginalItem =  ModAPI.FindSpawnable("Crossbow Bolt"),
        NameOverride =  " (Austria/Military) Feldmesser 81",
               DescriptionOverride =  "A very sharp blade used for stabbing or cooking.",
        CategoryOverride =  ModAPI.FindCategory("Entities"),
        ThumbnailOverride = ModAPI.LoadSprite("at11.png", 5f, true),
        AfterSpawn =  (Instance =>
        {
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("at11.png", 1f, true);
         Utils.FixColliders(Instance);


                })
      });







       
                    }

    }

}

